/*
 * This file is generated by jOOQ.
 */
package de.ship.clip.db.tables;


import de.ship.clip.db.Config;
import de.ship.clip.db.Keys;
import de.ship.clip.db.tables.records.TDisplaylabelRecord;

import java.util.function.Function;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Function3;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Records;
import org.jooq.Row3;
import org.jooq.Schema;
import org.jooq.SelectField;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDisplaylabel extends TableImpl<TDisplaylabelRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>config.t_displaylabel</code>
     */
    public static final TDisplaylabel T_DISPLAYLABEL = new TDisplaylabel();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDisplaylabelRecord> getRecordType() {
        return TDisplaylabelRecord.class;
    }

    /**
     * The column <code>config.t_displaylabel.pk</code>.
     */
    public final TableField<TDisplaylabelRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>config.t_displaylabel.label</code>.
     */
    public final TableField<TDisplaylabelRecord, String> LABEL = createField(DSL.name("label"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>config.t_displaylabel.langkey</code>.
     */
    public final TableField<TDisplaylabelRecord, String> LANGKEY = createField(DSL.name("langkey"), SQLDataType.CLOB, this, "");

    private TDisplaylabel(Name alias, Table<TDisplaylabelRecord> aliased) {
        this(alias, aliased, null);
    }

    private TDisplaylabel(Name alias, Table<TDisplaylabelRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>config.t_displaylabel</code> table reference
     */
    public TDisplaylabel(String alias) {
        this(DSL.name(alias), T_DISPLAYLABEL);
    }

    /**
     * Create an aliased <code>config.t_displaylabel</code> table reference
     */
    public TDisplaylabel(Name alias) {
        this(alias, T_DISPLAYLABEL);
    }

    /**
     * Create a <code>config.t_displaylabel</code> table reference
     */
    public TDisplaylabel() {
        this(DSL.name("t_displaylabel"), null);
    }

    public <O extends Record> TDisplaylabel(Table<O> child, ForeignKey<O, TDisplaylabelRecord> key) {
        super(child, key, T_DISPLAYLABEL);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Config.CONFIG;
    }

    @Override
    public Identity<TDisplaylabelRecord, Integer> getIdentity() {
        return (Identity<TDisplaylabelRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDisplaylabelRecord> getPrimaryKey() {
        return Keys.T_DISPLAYLABEL_PKEY;
    }

    @Override
    public TDisplaylabel as(String alias) {
        return new TDisplaylabel(DSL.name(alias), this);
    }

    @Override
    public TDisplaylabel as(Name alias) {
        return new TDisplaylabel(alias, this);
    }

    @Override
    public TDisplaylabel as(Table<?> alias) {
        return new TDisplaylabel(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDisplaylabel rename(String name) {
        return new TDisplaylabel(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDisplaylabel rename(Name name) {
        return new TDisplaylabel(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDisplaylabel rename(Table<?> name) {
        return new TDisplaylabel(name.getQualifiedName(), null);
    }

    // -------------------------------------------------------------------------
    // Row3 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row3<Integer, String, String> fieldsRow() {
        return (Row3) super.fieldsRow();
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Function)}.
     */
    public <U> SelectField<U> mapping(Function3<? super Integer, ? super String, ? super String, ? extends U> from) {
        return convertFrom(Records.mapping(from));
    }

    /**
     * Convenience mapping calling {@link SelectField#convertFrom(Class,
     * Function)}.
     */
    public <U> SelectField<U> mapping(Class<U> toType, Function3<? super Integer, ? super String, ? super String, ? extends U> from) {
        return convertFrom(toType, Records.mapping(from));
    }
}
